package org.wikimedia.discovery.cirrus.updater.common.model;

import java.time.Instant;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Map;

import org.apache.flink.api.java.functions.KeySelector;
import org.apache.flink.types.Row;
import org.wikimedia.discovery.cirrus.updater.common.util.function.SerializableFunction;

import com.google.common.base.Verify;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder(toBuilder = true)
public class UpdateEvent {

    public static final SerializableFunction<UpdateEvent, String> WIKIID_EXTRACTOR =
            u -> u.getTargetDocument().getWikiId();
    public static final KeySelector<UpdateEvent, PageKey> KEY_SELECTOR =
            i -> new PageKey(i.getTargetDocument().getWikiId(), i.getTargetDocument().getPageId());
    public static final String WEIGHTED_TAGS_DELETE_GROUPING = "__DELETE_GROUPING__";

    Meta meta;

    ChangeType changeType;

    Instant eventTime;

    public Instant getEventTime() {
        return eventTime != null ? eventTime : meta.getDt();
    }

    public String getRequestId() {
        return meta.getRequestId();
    }

    public String getEventStream() {
        return meta.getStream();
    }

    Long revId;
    Instant ingestionTime;
    TargetDocument targetDocument;
    TargetDocument movedFrom;
    Update update;

    Integer fetchAttempt;

    Boolean bypassDeduplication;

    /** Indicates the nature of the event source, only in the producer side. */
    @Builder.Default Boolean fromPrivateStream = Boolean.FALSE;

    public boolean hasFetchedFields() {
        return getUpdate() != null && getUpdate().getRawFieldsFetchedAt() != null;
    }

    public UpdateEvent createDerivedEvent() {
        UpdateEvent event = new UpdateEvent();
        event.setEventTime(getEventTime());
        // do not preset id, a new one should be generated by the sink serializer
        event.setMeta(getMeta().toBuilder().id(null).build());
        event.setIngestionTime(getIngestionTime());
        event.setRevId(getRevId());
        event.setFromPrivateStream(getFromPrivateStream());
        return event;
    }
    /** Targeting information for a single document in elasticsearch. */
    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    @Builder(toBuilder = true)
    public static class TargetDocument {

        private String domain;
        private String wikiId;
        private Long pageNamespace;
        private Long pageId;
        private String clusterGroup;
        private String indexName;
        // page title including namespace prefix, if applicable
        private String pageTitle;

        public TargetDocument(String domain, String wikiId, Long pageNamespace, Long pageId) {
            this.domain = domain;
            this.wikiId = wikiId;
            this.pageNamespace = pageNamespace;
            this.pageId = pageId;
        }

        public boolean isComplete() {
            return clusterGroup != null && indexName != null;
        }

        public TargetDocument completeWith(String clusterGroup, String indexName) {
            this.clusterGroup = clusterGroup;
            this.indexName = indexName;
            return this;
        }

        /** @return The page title in text format */
        public String getPageTitleTextForm() {
            return pageTitle.replace('_', ' ');
        }

        /** @return Return the page title, minus the namespace prefix, in text format */
        public String getUnprefixedPageTitleTextForm() {
            String textForm = getPageTitleTextForm();
            if (pageNamespace == 0) {
                return textForm;
            }
            int pos = textForm.indexOf(':');
            Verify.verify(pos > 0, "Page title must include : when namespace != 0");
            return textForm.substring(1 + pos);
        }
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    @Builder(toBuilder = true)
    public static class Update {

        public static final Map<String, String> WEIGHTED_TAGS_HINT =
                Collections.singletonMap(UpdateFields.WEIGHTED_TAGS, "multilist");

        public static final Map<String, String> REDIRECT_HINT =
                Collections.singletonMap(UpdateFields.REDIRECT, "set");

        private Map<String, String> noopHints;

        private List<String> weightedTags;

        private List<TargetDocument> redirectRemove;
        private List<TargetDocument> redirectAdd;

        private Instant rawFieldsFetchedAt;

        @EqualsAndHashCode.Exclude private Row rawFields;

        public static Update forWeightedTags(Collection<String> weightedTags) {
            return builder()
                    .noopHints(WEIGHTED_TAGS_HINT)
                    .weightedTags(
                            weightedTags == null || weightedTags.isEmpty() ? null : asList(weightedTags))
                    .build();
        }

        public static Update forRedirect(
                Collection<TargetDocument> add, Collection<TargetDocument> remove) {
            return builder()
                    .noopHints(REDIRECT_HINT)
                    .redirectAdd(add == null || add.isEmpty() ? null : asList(add))
                    .redirectRemove(remove == null || remove.isEmpty() ? null : asList(remove))
                    .build();
        }

        private static <T> List<T> asList(Collection<T> weightedTags) {
            return weightedTags instanceof List ? (List<T>) weightedTags : new ArrayList<>(weightedTags);
        }
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    @Builder(toBuilder = true)
    public static class Meta {
        /** Domain the event or entity pertains to. */
        String domain;
        /** Time the event was received by the system, in UTC ISO-8601 format. */
        Instant dt;
        /** Unique ID of this event. */
        String id;
        /** Unique ID of the request that caused the event. */
        String requestId;
        /** Name of the stream (dataset) that this event belongs in. */
        String stream;
        /** Unique URI identifying the event or entity. */
        String uri;
    }
}
